SystemOrganization addCategory: #'SeasideAsync-Platform'!
SystemOrganization addCategory: #'SeasideAsync-Tests'!
SystemOrganization addCategory: #'SeasideAsync-Rendering'!
SystemOrganization addCategory: #'SeasideAsync-Widgets'!
SystemOrganization addCategory: #'SeasideAsync-Renderers'!
SystemOrganization addCategory: #'SeasideAsync-Libraries'!
SystemOrganization addCategory: #'SeasideAsync-Browser'!

WAHtmlStreamDocument subclass: #WAXmlStreamDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Rendering'!

!WAXmlStreamDocument methodsFor: 'public' stamp: 'mb 7/6/2007 17:58'!
close
	self writeLoadScripts.
	self closeTag: '</body>'! !

!WAXmlStreamDocument methodsFor: 'public' stamp: 'mb 11/22/2006 15:14'!
writeLoadScripts
	| session renderer aStream |
	session := WACurrentSession value.
	(session isNil or: [ session onLoadScripts isEmpty ])
		ifTrue: [ ^ self ].
	renderer := WAStaticHtmlCanvas document: self.
	aStream := (String new: 200) writeStream.
	session onLoadScripts
		do: [ :each | aStream nextPutAll: each displayString ]
		separatedBy: [ aStream nextPut: $; ].
	renderer script: aStream contents.		
	session clearLoadScripts! !

WADecoration subclass: #WAClassBrowserDialogDecoration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAClassBrowserDialogDecoration methodsFor: 'rendering' stamp: 'mb 11/6/2006 11:50'!
renderContentOn: html
	self renderOwnerOn: html! !

!WAClassBrowserDialogDecoration methodsFor: 'rendering' stamp: 'mb 11/6/2006 12:13'!
style
	^'
div#lightbox {
	background-color: #edfced;
	border: 1px solid #e8a400;
	padding: 2em;
	width: 50%;
	font-family: Verdana;
}
div#lightbox h3 {
	font-weight: normal;
	font-size: 80%;
}
'! !

!WAClassBrowserDialogDecoration methodsFor: 'rendering' stamp: 'mb 7/9/2007 07:43'!
updateRoot: anHtmlRoot 
	| save |
	(SULibrary notNil
		and: [(self session application libraries includes: SULibrary) not])
			ifTrue: 
				["Naughty, dirty, awful hack to make sure SULibrary javascripts
				are all inserted at the beginning"
				save := OrderedCollection new.
				[anHtmlRoot scripts isEmpty]
					whileFalse: [save add: anHtmlRoot scripts removeFirst].
				SULibrary default updateRoot: anHtmlRoot.
				anHtmlRoot scripts addAll: save].
	super updateRoot: anHtmlRoot! !

WARenderCanvas subclass: #WAAsyncRenderCanvas
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Renderers'!

!WAAsyncRenderCanvas methodsFor: 'form-elements' stamp: 'mb 11/3/2006 11:43'!
dateInput
	^ self brush: WALiveDateInput new! !

!WAAsyncRenderCanvas methodsFor: 'encoding' stamp: 'mb 7/6/2007 17:12'!
encode: anObject 
	^ anObject displayString! !

!WAAsyncRenderCanvas methodsFor: 'xml' stamp: 'mb 11/9/2006 07:32'!
spaceEntity
	^'&#160;'! !

!WAAsyncRenderCanvas methodsFor: 'form-elements' stamp: 'mb 11/3/2006 11:43'!
timeInput
	^ self brush: WALiveTimeInput new! !

!WAAsyncRenderCanvas methodsFor: 'private' stamp: 'mb 7/6/2007 17:06'!
urlForLiveAction: actionBlock 
	^ context actionUrl
				withParameter: (self callbacks registerLiveActionCallback: actionBlock renderer: self).
! !

!WACheckboxTag methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 17:20'!
liveCallback: liveBlock
	| uri id |
	id := self ensureId.
	liveBlock fixCallbackTemps.
	uri := canvas urlForLiveAction: 
		[:event :h | liveBlock 
			value: event valueAsBoolean
			value: h].
	self session 
		addLoadScript: 
			'document.getElementById('
				, id asString printString
				, ').onclick = liveCheck(' 
				, id asString printString
				, ','
				, (canvas encode: uri asString) printString
				, ')'
! !

!WASelectTag methodsFor: '*seasideasync' stamp: 'mb 7/6/2007 18:11'!
isMultiple
	^false! !

!WASelectTag methodsFor: '*seasideasync' stamp: 'mb 4/7/2007 03:25'!
liveCallback: liveBlock
	| uri id |
	id := self ensureId.
	liveBlock fixCallbackTemps.
	uri := canvas
				urlForLiveAction: [:event :h | 
					| adjustedList values value |
					adjustedList := self isOptional ifTrue: [#(nil) , list] ifFalse: [list].
					values := event value asArray collect: 
								[:each | adjustedList at: each asInteger].
					self isMultiple
							ifTrue: 
								[liveBlock value: values value: h]
							ifFalse: 
								[value := values isEmpty
									ifTrue: [nil] ifFalse: [values first].
							liveBlock value: value value: h]].
	self session 
		addLoadScript: 
			'document.getElementById('
				, id asString printString
				, ').onchange = liveSelect('
				, id asString printString
				, ','
				, (canvas encode: uri asString) printString
				, ')'
! !

!WAMultiSelectTag methodsFor: '*seasideasync' stamp: 'mb 7/6/2007 18:11'!
isMultiple
	^ true! !

!WATagBrush methodsFor: '*seasideasync' stamp: 'mb 1/29/2007 14:30'!
forEvent: aString callback: callback 
	| uri |
	callback fixCallbackTemps. 
	uri := canvas
				urlForLiveAction: [:event :renderer | 
					callback numArgs = 0 ifTrue: 
						[callback value] ifFalse: 
					[callback numArgs = 1 ifTrue: 
						[callback value: event] ifFalse: 
					[callback value: event value: renderer]]].
	self attributes
		at: aString
		append: 'liveEventTrackerUri(event,' , (canvas encode: uri asString) printString , ')'
		separator: ';'
! !

!WATagBrush methodsFor: '*seasideasync' stamp: 'mb 3/31/2006 08:54'!
onClickCallback: aBlock
	self forEvent: 'onclick' callback: aBlock ! !

!WATagBrush methodsFor: '*seasideasync' stamp: 'mb 3/31/2006 08:54'!
onFocusCallback: aBlock
	self forEvent: 'onfocus' callback: aBlock ! !

!WATagBrush methodsFor: '*seasideasync' stamp: 'mb 7/6/2007 16:31'!
refreshWith: liveBlock every: aDuration
	" I refresh myself every aDuration with aBlock.
	No overlapping executions will take place, the next refresh is only scheduled after the block finished executing "
	| uri id |
	id := self ensureId.
	liveBlock fixCallbackTemps.
	uri := canvas urlForLiveAction:
			[ :event :renderer |
			event
				type: 'refresh';
				elementTagName: self tag;
				elementType: self tag;
				elementValue: aDuration;				
				elementId: id.
			(renderer tag: self tag)
				id: id; 
				with: [liveBlock value: event value: renderer].].
	self session
		addLoadScript: 
			'timedUpdate('
				, (canvas encode: uri asString) printString
				, ', ' 
				, aDuration asMilliSeconds printString
				, ')'
! !

WAComponent subclass: #WAAsyncComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Rendering'!

WAAsyncComponent subclass: #WAAsyncAutoCompleteTest
	instanceVariableNames: 'autocomplete inputValue inputValueComplete selectedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Tests'!

!WAAsyncAutoCompleteTest class methodsFor: 'class initialization' stamp: 'mb 7/6/2007 15:41'!
description
	^'Auto-completion examples'! !

!WAAsyncAutoCompleteTest class methodsFor: 'class initialization' stamp: 'mb 7/6/2007 15:36'!
initialize
	self registerAsApplication: 'tests/async/autocomplete'! !

!WAAsyncAutoCompleteTest methodsFor: 'rendering' stamp: 'mb 3/5/2006 22:51'!
children
	^Array with: autocomplete! !

!WAAsyncAutoCompleteTest methodsFor: 'initialize-release' stamp: 'mb 7/6/2007 16:59'!
initialize
	super initialize.
	autocomplete := WAAutoCompleteEntryField new name: 'Choose a class:';
				 listHeight: 8;
				 listWidth: 40;
				 yourself! !

!WAAsyncAutoCompleteTest methodsFor: 'constants' stamp: 'mb 2/24/2006 14:48'!
namelist
	^#(Andrew Bengt Chuck Daniel Elmer Franz George Henry Isildur) ,
		#(Jefferson Jeffrey Jeremy Jerry John Josuah Kleber Lewis Mike) , 
			#( Nancy Oscar Peter Robert Roger Stephen Steven Tobias Vincent William)! !

!WAAsyncAutoCompleteTest methodsFor: 'rendering' stamp: 'mb 7/6/2007 14:12'!
renderAutoCompleteOn: html 
	| selection |
	html div id: #autoComplete;
		with: 
			[(inputValue isEmptyOrNil not and: [inputValueComplete not]) 
				ifTrue:
					[selection := self namelist 
								detect: [:ea | (ea copyFrom: 1 to: (inputValue size min: ea size)) asUppercase = inputValue asUppercase]
								ifNone: [nil].
					html select 
						id: #autoCompleteSelect;
						list: self namelist;
						size: 3;
						selected: selection;
						callback:
							[:v |
							inputValue := v.
							inputValueComplete := true];
						labels: [:ea | ea];
						liveCallback: 
							[:v :h | 
							inputValue := v.
							inputValueComplete := true.
							self renderTextFieldOn: h]]].
	html script: 'document.getElementById("autoComplete").style.width = document.getElementById("input").style.width'.
	! !

!WAAsyncAutoCompleteTest methodsFor: 'rendering' stamp: 'mb 7/6/2007 14:30'!
renderContentOn: html 
	| classes |


	html heading
		level: 3;
		with: 'AutoComplete Test (two different techniques)'.
	html break.

	html form
		defaultAction: [self inform: inputValue];
		with: [
			self renderTextFieldOn: html.
			html submitButton text: 'Go'].

	classes := (Object withAllSubclasses reject: [:e | e class = Metaclass]) asArray.

	autocomplete objects: classes strings: (classes collect: [:e | e name]).
	autocomplete callback: [:class | selectedClass := class].

	html form
		with: [
			html 
				text: 'You have selected: ';
				text: (selectedClass isNil ifTrue: ['Nothing'] ifFalse: [selectedClass name]);
				break;
				break.
			html render: autocomplete.
			html submitButton callback: []; text: 'Go'].
! !

!WAAsyncAutoCompleteTest methodsFor: 'rendering' stamp: 'mb 7/6/2007 14:17'!
renderTextFieldOn: html
	html div
		id: #input;
		style: 'width: 15em';
		with: [
			html textInput
				id: #inputField;
				value: inputValue;
				callback:
					[:v |
					inputValue := v. 
					inputValueComplete := true];
				liveCallback: 
					[:v :h | 
					inputValue := v.
					inputValueComplete := false.
					self renderAutoCompleteOn: h]].
	self renderAutoCompleteOn: html! !

!WAAsyncAutoCompleteTest methodsFor: 'css' stamp: 'mb 3/5/2006 23:19'!
style
	^'
#input input {
	width: 100%;
}
#autoComplete select {
	background-color: lightyellow;
	width: 100%;
}
form {
	width: 60%; 
	border: 1px solid green;
	padding: 5px;
	background-color: lightyellow;
}
'! !

!WAAsyncComponent class methodsFor: 'registration' stamp: 'mb 11/3/2006 18:20'!
registerAsApplication: appName
	^(super registerAsApplication: appName)
		addLibrary: WAAsyncScripts;
		yourself
		! !

!WAAsyncComponent class methodsFor: 'registration' stamp: 'mb 11/3/2006 18:20'!
registerAsAuthenticatedApplication: appName
	^(super registerAsAuthenticatedApplication: appName)
		addLibrary: WAAsyncScripts;
		yourself
		! !

!WAAsyncComponent methodsFor: 'rendering' stamp: 'mb 7/6/2007 14:20'!
rendererClass
	^ WAAsyncRenderCanvas! !

WAAsyncComponent subclass: #WAAsyncFocusTest
	instanceVariableNames: 'log cbValue selected radioValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Tests'!

!WAAsyncFocusTest class methodsFor: 'initialization' stamp: 'mb 7/6/2007 15:39'!
description
	^'How application can be aware of which entry item had the focus'! !

!WAAsyncFocusTest class methodsFor: 'initialization' stamp: 'mb 7/6/2007 15:38'!
initialize
	self registerAsApplication: 'tests/async/focuscapture'.! !

!WAAsyncFocusTest methodsFor: 'initialization' stamp: 'mb 11/14/2006 22:56'!
clearLog
	log := OrderedCollection new.
! !

!WAAsyncFocusTest methodsFor: 'initialization' stamp: 'mb 7/6/2007 16:59'!
initialize
	super initialize.
	self clearLog.
	cbValue := false.
	radioValue := false! !

!WAAsyncFocusTest methodsFor: 'rendering' stamp: 'mb 1/29/2007 14:13'!
renderContentOn: html 
	| group |
	html form
		with:
			[
			html textInput
				onFocusCallback: [:event | log add: 'Entry field' -> event value];
				callback: [:v | ].
			html select
				list: #( a b c );
				onFocusCallback: [:event | log add: 'Select box' -> event value];
				selected: selected.
			html checkbox
				onClickCallback: [:event | log add: 'Checkbox' -> event value];
				value: cbValue;
				callback: [:v | cbValue := v].
			html span
				style: 'border: 1px dashed grey';
				with:
					[group := html radioGroup.
					html radioButton
						group: group;
						onFocusCallback: [:event | log add: 'radio(left)' -> event value]; "Does not work in Safari 2.0.4"
						selected: radioValue;
						callback: [:v | radioValue := false].
					html radioButton
						group: group;
						onFocusCallback: [:event | log add: 'radio(right)' -> event value]; "Does not work in Safari 2.0.4"
						selected: radioValue not;
						callback: [:v | radioValue := true].
					].
			html submitButton].
	html div: 'Radio buttons do not work with Safari, because Safari does not support onclick for radio buttons'.
	log notEmpty ifTrue: [self renderLogOn: html]! !

!WAAsyncFocusTest methodsFor: 'rendering' stamp: 'mb 7/9/2007 07:27'!
renderLogOn: html 
	html
		paragraph: [html text: 'Before button was clicked, field with focus was:';
				 break;
				 strong: log last key;
				 break;
				 text: 'At that time the field received the focus, its value was:';
				 break;
				 strong: log last value].
	html heading: 'Captured events' level: 5.
	log
		do: [:each | html text: each printString]
		separatedBy: [html break].
	self clearLog! !

WAAsyncComponent subclass: #WAAsyncLiveRequestTest
	instanceVariableNames: 'input1 input2 selection count bool country province city date booleans time multiSelected nSelection selectedCurrency selectedCountry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Tests'!

!WAAsyncLiveRequestTest class methodsFor: 'testing' stamp: 'mb 10/29/2005 11:39'!
canBeRoot
	^ true! !

!WAAsyncLiveRequestTest class methodsFor: 'initialization' stamp: 'mb 7/6/2007 15:42'!
description
	^'Live update examples'! !

!WAAsyncLiveRequestTest class methodsFor: 'initialization' stamp: 'mb 7/6/2007 15:41'!
initialize
	self registerAsApplication: 'tests/async/livetests'.! !

!WAAsyncLiveRequestTest methodsFor: 'nested' stamp: 'mb 8/16/2006 14:10'!
city: anObject
	city := anObject.
! !

!WAAsyncLiveRequestTest methodsFor: 'nested' stamp: 'mb 11/14/2006 23:01'!
cityNames
	province = 'Oranjestad'
		ifTrue: [^#( 'Casibari' 'Bubali')	].
	province = 'Santa Cruz'
		ifTrue: [^#( 'Arikok' 'Yamonta')	].
	province = 'Buenos Aires'
		ifTrue: [^#('La Plata' 'Azul')].
	province = 'Cordoba'
		ifTrue: [^#('Alta Gracia' 'La Falda')].
	province = 'California'
		ifTrue: [^#('Los Angeles' 'Monterey' 'San Jose' 'Santa Monica')].
	province = 'Ohio'
		ifTrue: [^#('Cincinnati' 'Dayton' 'Clifton')].
	^#()


! !

!WAAsyncLiveRequestTest methodsFor: 'nested' stamp: 'mb 8/16/2006 14:11'!
country: anObject
	country := anObject. 
	self province: self provinceNames first. 
! !

!WAAsyncLiveRequestTest methodsFor: 'initialization' stamp: 'mb 7/6/2007 17:00'!
initialize
	super initialize.
	count := 0.
	bool := false.
	input1 := String new.
	input2 := String new.
	multiSelected := #(0 7 ).
	self country: 'Argentina'.
	booleans := Dictionary new at: #English put: true;
				 at: #Russian put: false;
				 at: #Japanese put: false;
				 yourself! !

!WAAsyncLiveRequestTest methodsFor: 'nested' stamp: 'mb 11/14/2006 22:57'!
province: anObject
	province := anObject.
	self city: self cityNames first.

! !

!WAAsyncLiveRequestTest methodsFor: 'nested' stamp: 'mb 11/14/2006 22:59'!
provinceNames
	country = 'Aruba'
		ifTrue: [^#('Oranjestad' 'Santa Cruz')].
	country = 'Argentina'
		ifTrue: [^#( 'Buenos Aires' 'Cordoba')].
	country = 'USA'
		ifTrue: [^#( 'Ohio' 'California')].
	^#()


! !

!WAAsyncLiveRequestTest methodsFor: 'rendering' stamp: 'mb 5/3/2007 15:41'!
renderAnchorOn: html 
	html anchor
		callback: ["The live callback disables the regular callback"
			self error: 'Should not come here'];
		 onClick: 'debug("Good that you clicked that link, thanks from a piece of Javascript.")';
		
		liveCallback: [:h | 
			"The live callback does not disable previous onclick"
			h span id: 'timestamp';
				 with: TimeStamp now.
			h span id: 'time';
				 with: Time now];
		 with: 'Show time'.
	html space.
	html span id: 'timestamp';
		 with: ''! !

!WAAsyncLiveRequestTest methodsFor: 'rendering' stamp: 'mb 1/29/2007 11:24'!
renderButtonOn: html 
	html
		form: [html submitButton
				callback: ["The live callback disables the regular callback"
					self error: 'Should not come here'];
				"The live callback does not disable previous onclick"

				 onClick: 'debug("Good that you clicked that button, thanks from a piece of Javascript.")';
				
				liveCallback: [:h | 
					h span id: 'timestamp-button';
						 with: TimeStamp now.
					h span id: 'time';
						 with: Time now];
				 text: 'Show time';
				"The live callback disables any subsequent onclick"
				
				 onClick: 'debug("This should not display")'
			].
	html space.
	html span id: 'timestamp-button';
		 with: ''! !

!WAAsyncLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/20/2005 16:41'!
renderCheckBoxOn: html

	html form:
		[html checkbox
				value: bool; 
				callback: [:v | bool := v];
				liveCallback: 
					[:item :h |
					bool := item.
					"Update multiple areas of the document using one live callback"
					h span id: 'checkbox'; with: (bool ifTrue: ['checked'] ifFalse: ['unchecked']).
					h span id: 'chk'; with: (bool ifTrue: ['checked'] ifFalse: ['unchecked']).
					].
			
		html space.
		html span id: 'chk'; with: (bool ifTrue: ['checked'] ifFalse: ['unchecked']).
		].
	! !

!WAAsyncLiveRequestTest methodsFor: 'nested' stamp: 'mb 11/14/2006 22:58'!
renderCitiesOn: html

	html span id: 'citySelector'; with:
		[(html select)
			list: self cityNames;
			selected: city;
			callback:[:f | city := f ];						
			labels: [:ea |  ea ]]		
! !

!WAAsyncLiveRequestTest methodsFor: 'rendering' stamp: 'mb 7/6/2007 17:15'!
renderContentOn: html 
	self renderWarningOn: html.
	html
		table: [html
				tableRow: [html
						tableData: [self renderInput1On: html.
							self renderInput2On: html.
							self renderDateInputOn: html.
							self renderTimeInputOn: html.
							self renderListOn: html.
							self renderMultiSelectOn: html.
							self renderCheckBoxOn: html.
							self renderRadioOn: html.
							self renderAnchorOn: html.
							html break.
							self renderButtonOn: html].
					html
						tableData: [html heading level:3; with: 'Forward'.
							html div id: 'forward';
								 with: ''.
							html heading level:3; with: 'Backward'.
							html div id: 'backward';
								 with: ''.
							html heading level:3; with: 'Date'.
							html div id: 'date';
								 with: ''.
							html heading level:3; with: 'Time'.
							html div id: 'xtime';
								 with: ''.
							html heading level:3; with: 'Selection'.
							html span id: 'selection';
								 with: ''.
							html heading level:3; with: 'Multiple Selection'.
							html span id: 'multiselect';
								 with: ''.
							html heading level:3; with: 'Checkbox'.
							html span id: 'checkbox';
								 with: ''.
							html heading level:3; with: 'Radio buttons'.
							html span id: 'radio';
								 with: booleans printString.
							html heading level:3; with: 'Time'.
							html span id: 'time';
								 with: '']]].
	html heading level:3; with: 'Nested live callbacks'.
	self renderCountriesOn: html.
	self renderCurrenciesOn: html.
	self renderWarningOn: html! !

!WAAsyncLiveRequestTest methodsFor: 'nested' stamp: 'mb 11/14/2006 22:58'!
renderCountriesOn: html
	(html select)
		list: #( 'Argentina' 'Aruba' 'USA' );
		selected: country;
		callback: [:f | country := f]; 
		labels: [:ea |  ea ];
		liveCallback: 
			[:anObject :h | 
			country := anObject. 
			province := self provinceNames first. 
			city := self cityNames first.
			self renderProvincesOn: h].

	self renderProvincesOn: html.
! !

!WAAsyncLiveRequestTest methodsFor: 'nested' stamp: 'mb 6/5/2007 16:21'!
renderCountryListOn: html

	html span
		id: 'countryList';
		with: 
			[selectedCurrency notNil ifTrue:
				[selectedCurrency == #Euros ifTrue: [
					html select 
						list: #(Germany France Spain Italy Belgium Ireland Austria Luxemburg Netherlands);
						beOptional;
						optionalLabel: '<Select a ''country'' & watch>'; "May not contain angle brackets"
						selected: selectedCountry; 
						labels: [:ea | ea displayString];
						liveCallback:
							[:item :h |
							selectedCountry := item. 
							self renderCountryStatusOn: h].
					html space.
					self renderCountryStatusOn: html]
				ifFalse:
					[html text: 'This is not euro, cannot show euroland countries']]]! !

!WAAsyncLiveRequestTest methodsFor: 'nested' stamp: 'mb 6/5/2007 11:33'!
renderCountryStatusOn: html

	html span
		id: 'countryStatus';
		with: 
			[selectedCountry notNil ifTrue:
				[html text: 'That''s correct, ' , selectedCountry displayString , ' uses Euros']].
! !

!WAAsyncLiveRequestTest methodsFor: 'nested' stamp: 'mb 6/5/2007 11:33'!
renderCurrenciesOn: html

	html form:
		[html select 
				list: #(Euros Dollars Yens);
				beOptional;
				optionalLabel: '<select a currency>';
				selected: selectedCurrency; 
				labels: [:ea | ea displayString];
				liveCallback:
					[:item :h |
					selectedCurrency := item. 
					self renderCountryListOn: h].
		html space.
		self renderCountryListOn: html]
! !

!WAAsyncLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/4/2006 12:14'!
renderDateInputOn: html

	html form:
		[html dateInput
			value: date;
			liveCallback:
					[:value :h |
					date := value.
					h div id: 'date'; with: date.
					h span id: 'dat'; with: 'Value entered= ' , date displayString.
					].
		html space.
		html span id: 'dat'; with: 'Value entered= ' , date displayString.
		].! !

!WAAsyncLiveRequestTest methodsFor: 'rendering' stamp: 'mb 1/29/2007 14:14'!
renderInput1On: html

	html form:
		[html textInput
				value: input1; 
				callback: [:v | input1 := v];
				liveCallback: 
					[:text :h |
					input1 := text. 
					"Update multiple areas of the document using one live callback"
					h div id: 'forward'; with:
						[h unorderedList:
							[input1 do:
								[:c | 
								h listItem:
									[h anchor 
									callback: [self inform: c displayString];
									text: c displayString]]]].
					h span id: 'fwd'; with:
						[h text: 'Value entered= ' , input1.
						h script: 'debug("javascript in a live callback ' , input1 , ' ");']
					].
		html space.
		html span id: 'fwd'; with:'Value entered= ' , input1.
		html break.
		html text: 'Above: Javascript attached= debug("Javascript in a live callback xxx ");'
		].
! !

!WAAsyncLiveRequestTest methodsFor: 'rendering' stamp: 'mb 9/8/2006 10:14'!
renderInput2On: html

	html form:
		[html textArea
				value: input2;
				callback: [:v | input2 := v];
				liveCallback: 
					[:text :h |
					input2 := text.
					h div id: 'backward'; with: 
						[h unorderedList: 
							[input2 reverse do: 
								[:c |
								h listItem: 
									[h anchor 
										callback: [self inform: c displayString];
										text: c displayString]]]].
					h span id: 'bwd'; with: 'Value entered= ' , input2
					].
		html space.
		html span id: 'bwd'; with: 'Value entered= ' , input2
		].
! !

!WAAsyncLiveRequestTest methodsFor: 'rendering' stamp: 'mb 6/5/2007 11:03'!
renderListOn: html

	html form:
		[html select 
				list: #(Horse Cat Dog Camel Cow Pterodactyl);
				beOptional;
				optionalLabel: '<select>';
				selected: selection; 
				labels: [:ea | ea displayString];
				liveCallback:
					[:item :h |
					selection := item. 
					"Update multiple areas of the document using one live callback"
					h span id: 'selection'; with: selection.
					h span id: 'sel'; with: 'Value selected= ' , selection displayString
					].
		html space.
		html span id: 'sel'; with: 'Value selected= ' , selection displayString
		].
! !

!WAAsyncLiveRequestTest methodsFor: 'rendering' stamp: 'mb 7/6/2007 18:15'!
renderMultiSelectOn: html 
	html
		form: [html multiSelect list: #(0 1 2 3 4 5 6 7 8 9 );
				 selected: multiSelected;
				
				labels: [:ea | ea displayString];
				
				callback: [:aCollection | multiSelected := aCollection];
				
				liveCallback: [:aCollection :h | 
					multiSelected := aCollection.
					h span id: 'multiselect';
						 with: multiSelected.
					h span id: 'multisel';
						 with: 'Values selected= ' , multiSelected displayString].
			html space.
			html span id: 'multisel';
				 with: 'Values selected= ' , multiSelected displayString]! !

!WAAsyncLiveRequestTest methodsFor: 'nested' stamp: 'mb 11/14/2006 22:58'!
renderProvincesOn: html

	html span id: 'provinceSelector'; with:
		[(html select)
			list:  self provinceNames;
			selected: province;
			callback: [:f | province := f]; 
			labels: [:ea |  ea ];
			liveCallback: 
				[:anObject :h | 
				province := anObject. 
				city := self cityNames first.
				self renderCitiesOn: h]].
	self renderCitiesOn: html.


! !

!WAAsyncLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/3/2006 17:53'!
renderRadioOn: html
	html
		form: [
			html table: [
				html tableRow: [
					html tableData: 'Language'.
					html tableData: 'Yes'.
					html tableData: 'No'].

				booleans associationsDo:
					[:assoc | 
					| group |
					html tableRow: [
						group := html radioGroup.
						html tableData: assoc key.
						html tableData: [
							(html radioButton)
								id: assoc key asString , '-on';
								group: group;
								selected: assoc value;
								liveCallback:
									[:item :h |
									assoc value: true.
									h span id: 'radio'; with: booleans printString]].
						html tableData: [
							(html radioButton)
								id: assoc key asString , '-off';
								group: group;
								selected: assoc value not;
								liveCallback:
									[:item :h |
									assoc value: false.
									h span id: 'radio'; with: booleans printString.]].
					]].
			]]
! !

!WAAsyncLiveRequestTest methodsFor: 'rendering' stamp: 'mb 11/4/2006 12:14'!
renderTimeInputOn: html

	html form:
		[html timeInput
			value: time;
			liveCallback:
					[:value :h |
					time := value.
					h div id: 'xtime'; with: time.
					h span id: 'tim'; with: 'Value entered= ' , time displayString.
					].
		html space.
		html span id: 'tim'; with: 'Value entered= ' , time displayString.
		].! !

!WAAsyncLiveRequestTest methodsFor: 'rendering' stamp: 'mb 1/6/2006 11:38'!
renderWarningOn: html 
	"The #insert: method was not available in 2.6a1"
	(html respondsTo: #insert:) ifFalse:
		[html heading: 'Warning : Canvas rendering is unfinished in this release' level: 2]   ! !

WAAsyncComponent subclass: #WAAsyncPeriodicRequestTest
	instanceVariableNames: 'log'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Tests'!

!WAAsyncPeriodicRequestTest class methodsFor: 'class initialization' stamp: 'mb 7/6/2007 15:42'!
description
	^'Periodical update examples'! !

!WAAsyncPeriodicRequestTest class methodsFor: 'class initialization' stamp: 'mb 7/6/2007 15:42'!
initialize
	self registerAsApplication: 'tests/async/periodictests'.! !

!WAAsyncPeriodicRequestTest methodsFor: 'initialization' stamp: 'mb 7/6/2007 17:00'!
initialize
	super initialize.
	log := String new writeStream! !

!WAAsyncPeriodicRequestTest methodsFor: 'rendering' stamp: 'mb 7/6/2007 15:52'!
renderContentOn: html

	self renderRefreshedElementsOn: html.
	self renderRefreshedLogOn: html.! !

!WAAsyncPeriodicRequestTest methodsFor: 'rendering' stamp: 'mb 7/6/2007 15:54'!
renderLogOn: html
	html withLineBreaks: log contents! !

!WAAsyncPeriodicRequestTest methodsFor: 'rendering' stamp: 'mb 7/6/2007 16:36'!
renderRefreshedElementsOn: html 
	| liveUpdateBlock |
	liveUpdateBlock := [:event :h | 
				log nextPutAll:
						'Timed log ' , event type , 
						' at ' , Time now printString , 
						' for ' , event elementType ,
						' id=' , event elementId;
					 cr;
					 nextPut: Character lf.
			h text: Time now printString].
	html table
		with: [html tableRow
				with: [html tableData with: 'Current Time in default div:'.
					html tableData
						with: ["Anonymous div."
							log nextPutAll: 'Anonymous div id=' , html peekNextId; cr; nextPut: Character lf.
							html div refreshWith: liveUpdateBlock every: 3 seconds]].
			html tableRow
				with: [html tableData with: 'Current Time in default span:'.
					html tableData
						with: ["Anonymous span. "
							log nextPutAll: 'Anonymous span id=' , html peekNextId; cr; nextPut: Character lf.
							html span refreshWith: liveUpdateBlock every: 5 seconds]].
			html tableRow
				with: [html tableData with: 'Current Time in named div:'.
					html tableData
						with: ["Named div"
							log nextPutAll: 'Named div id=livediv'; cr; nextPut: Character lf.
							html div id: 'livediv';
								 refreshWith: liveUpdateBlock every: 1 seconds]].
			html tableRow
				with: [html tableData with: 'Current Time in named span:'.
					html tableData
						with: ["Named span"
							log nextPutAll: 'Named span id=livespan'; cr; nextPut: Character lf.
							html span id: 'livespan';
								 refreshWith: liveUpdateBlock every: 2 seconds]]]! !

!WAAsyncPeriodicRequestTest methodsFor: 'rendering' stamp: 'mb 7/6/2007 16:11'!
renderRefreshedLogOn: html
	html heading level: 3; with: 'Refreshed log'.
	html div
		id: 'log';
		refreshWith:
			[ :event :h | 
			h break.
			self renderLogOn: h]
	 	every: 5 seconds 
			
! !

WAAsyncComponent subclass: #WAAutoCompleteEntryField
	instanceVariableNames: 'callback selectedObject listHeight name listWidth stringsToObjects strings prefix selectedString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Widgets'!

!WAAutoCompleteEntryField commentStamp: '<historical>' prior: 0!
This widget is a contribution from Anthony Lander
(anthony@etherealplanet.org)!

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:45'!
callback: aOneArgumentBlock
	"When a selection is made, aOneArgumentBlock is evaluated with the selected object"

	callback := aOneArgumentBlock! !

!WAAutoCompleteEntryField methodsFor: 'initialize-release' stamp: 'mb 7/6/2007 15:01'!
initialize

	super initialize.
	stringsToObjects := Dictionary new.
	strings := #().
	prefix := ''.
	selectedString := nil.
	selectedObject := nil.
	listHeight := 5.
	listWidth := 30.! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:45'!
listHeight: numberOfLines
	listHeight := numberOfLines! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:45'!
listWidth: numberOfCharacters
	listWidth := numberOfCharacters! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:48'!
name: aString
	name := aString! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:50'!
numberOfItems
	^stringsToObjects size! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 7/6/2007 15:08'!
objects: objects strings: objectLabels

	strings := objectLabels.
	stringsToObjects := Dictionary new: objects size.
	objectLabels with: objects
		do: [:label :object | stringsToObjects at: label put: object].
	prefix := ''.
	selectedString := nil.
	selectedObject := nil.! !

!WAAutoCompleteEntryField methodsFor: 'rendering' stamp: 'mb 7/6/2007 15:21'!
renderAutoCompleteSuggestionListOn: html 
	| labelsMatchingPrefix prefixPattern |
	html div id: 'D';
		with: 
			[(prefix isEmptyOrNil not and: [selectedString isNil]) 
				ifTrue: 
					[prefixPattern := prefix asUppercase , '*'.
					labelsMatchingPrefix := (strings 
								select: [:label | prefixPattern match: label asUppercase]) 
									asSortedCollection asArray.
					labelsMatchingPrefix isEmpty 
						ifTrue: 
							[selectedString := ''.
							selectedObject := nil]
						ifFalse: 
							[labelsMatchingPrefix size = 1 
								ifTrue: 
									[prefix := selectedString := labelsMatchingPrefix first.
									selectedObject := stringsToObjects at: selectedString].
							self renderSuggestionListLabels: labelsMatchingPrefix on: html]]]
	! !

!WAAutoCompleteEntryField methodsFor: 'rendering' stamp: 'mb 7/9/2007 07:26'!
renderAutoCompleteTextFieldOn: html 
	html div class: 'autocomplete';
		 id: 'autocomplete';
		 style: 'width: ' , (listWidth + name size) printString , 'em';
		
		with: [html div class: 'label';
				 id: 'L';
				 with: name.
			html div class: 'input';
				 id: 'I';
				
				with: [html textInput attributeAt: #autocomplete put: 'off';
						 style: 'width: ' , listWidth printString , 'em';
						 value: prefix;
						
						callback: [:v | 
							prefix := v.
							callback value: selectedObject.
							html strong: prefix];
						
						liveCallback: [:v :h | 
							prefix := v.
							selectedString := nil.
							self renderAutoCompleteSuggestionListOn: h].
					self renderAutoCompleteSuggestionListOn: html]]! !

!WAAutoCompleteEntryField methodsFor: 'rendering' stamp: 'mb 7/6/2007 15:26'!
renderContentOn: html 
	self numberOfItems < listHeight
		ifTrue: ["When the list is small, i.e. smaller than the number of items to
			be shown,
			show a drop-down list"
			self renderSimpleDropDownOn: html]
		ifFalse: ["When the list is large, use anchors"
			self renderAutoCompleteTextFieldOn: html]! !

!WAAutoCompleteEntryField methodsFor: 'rendering' stamp: 'mb 7/6/2007 15:16'!
renderSimpleDropDownOn: html 
	| objectsToLabels |
	objectsToLabels := IdentityDictionary new.
	stringsToObjects
		keysAndValuesDo: [:label :object | objectsToLabels at: object put: label].
	html div class: 'autocomplete';
		 id: 'autocomplete';
		
		with: [html div class: 'label';
				 id: 'L';
				
				with: [html text: name].
			html div
				class: 'input';
				id: 'I';
				with: [html select list: strings;
						 selected: strings first;
						
						callback: [:l | 
							selectedObject := stringsToObjects at: l.
							callback value: selectedObject]]]! !

!WAAutoCompleteEntryField methodsFor: 'rendering' stamp: 'mb 7/6/2007 15:34'!
renderSuggestionListLabels: labels on: html

	html div
		class: 'dropdown';
		with: 
			[html unorderedList with: 
				[(labels copyFrom: 1 to: (labels size min: listHeight))
					do: 
						[:label | 
						html listItem: 
							[html 
								anchor callback: [];
								liveCallback: 
									[:h | 
									selectedString := prefix := label.
									selectedObject := stringsToObjects at: label.
									callback value: selectedObject.
									self renderAutoCompleteTextFieldOn: h];
								with: label]]]]! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:48'!
selectedObject
	^selectedObject! !

!WAAutoCompleteEntryField methodsFor: 'accessing' stamp: 'mb 3/5/2006 22:47'!
selectedObject: anObject string: aString
	prefix := selectedString := aString.
	selectedObject := anObject.! !

!WAAutoCompleteEntryField methodsFor: 'css' stamp: 'mb 7/6/2007 14:59'!
style
 	^'
	.autocomplete { font-family: Tahoma, Arial, Helvetica; font-size: 100%;  }
	.autocomplete .label { width: 10em; float: left; text-align: right; font-weight: bold;  }
	.autocomplete .input { float: left; margin-left: 1em; }

	.dropdown { overflow: hidden; border-width: 1px; border-style: solid; border-color: black; }
	.dropdown ul { list-style-type: none; margin: 0; padding: 0; }
	.dropdown ul li { clear: left; float: left; display: inline; width: 100%; line-height: 1.1em; }
	.dropdown ul li.selected { font-weight: bold; line-height: 1.1em; }

	.dropdown a { display: block; padding: 3px; background-color: #036; border-bottom: 1px solid #eee; }
	.dropdown a:link, .dropdown a:visited { color: #EEE; text-decoration: none; }
	.dropdown a:hover { background-color: #369; color: #fff; }
'! !

WAAsyncComponent subclass: #WAClassBrowserPane
	instanceVariableNames: 'componentName main'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

WAClassBrowserPane subclass: #WAClassBrowserLeftPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAClassBrowserLeftPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:48'!
renderClassesListOn: html 
	(html select)
		size: self listSize;
		id: 'classList';
		selected: self selectedClass;
		list: self classes;
		liveCallback:
			[:value :renderer |
			main selectClass: value on: renderer].
! !

!WAClassBrowserLeftPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:44'!
renderClassesOn: html 
	(html div)
		id: 'classes';
		with: [ self renderClassesListOn: html ]! !

!WAClassBrowserLeftPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:23'!
renderContentOn: html 
	self renderPackagesOn: html.
	self renderClassesOn: html.! !

!WAClassBrowserLeftPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:49'!
renderPackagesListOn: html 
	(html select)
		size: self listSize;
		id: 'packageList';
		selected: self package;
		list: self packages;
		liveCallback:
			[:value :renderer |
			main selectPackage: value on: renderer].
! !

!WAClassBrowserLeftPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:45'!
renderPackagesOn: html 
	(html div)
		id: 'packages';
		with: [ self renderPackagesListOn: html ].! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 18:25'!
canRemoveSourceCode
	^self main canRemoveSourceCode! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/18/2006 14:28'!
canRenameSourceCode
	^self main canRenameSourceCode! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 18:22'!
canSaveSourceCode
	^self main canSaveSourceCode! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:56'!
classes
	^self main classes! !

!WAClassBrowserPane methodsFor: 'accessing' stamp: 'mb 10/13/2006 12:55'!
componentName
	"Answer the value of componentName"

	^ componentName! !

!WAClassBrowserPane methodsFor: 'accessing' stamp: 'mb 10/13/2006 12:55'!
componentName: anObject
	"Set the value of componentName"

	componentName := anObject! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:56'!
isReadOnly
	^self main isReadOnly! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:56'!
isReadOnly: aBoolean
	^self main isReadOnly: aBoolean! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:57'!
listSize
	^self main listSize! !

!WAClassBrowserPane methodsFor: 'accessing' stamp: 'mb 10/13/2006 12:55'!
main
	"Answer the value of main"

	^ main! !

!WAClassBrowserPane methodsFor: 'accessing' stamp: 'mb 10/13/2006 12:55'!
main: anObject
	"Set the value of main"

	main := anObject! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:57'!
package
	^self main package! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:57'!
package: anObject
	^self main package: anObject! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:57'!
packages
	^self main packages! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:57'!
pause
	^self main pause! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:58'!
protocol
	^self main protocol! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 12:58'!
protocol: anObject
	^self main protocol: anObject! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:19'!
protocols
	^self main protocols! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:20'!
selectedClass
	^self main selectedClass! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:20'!
selectedClass: anObject
	^self main selectedClass: anObject! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:21'!
selector
	^self main selector! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:21'!
selector: anObject
	^self main selector: anObject! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:21'!
selectors
	^self main selectors! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:21'!
sourceCode
	^self main sourceCode! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:21'!
sourceTitle
	^self main sourceTitle! !

!WAClassBrowserPane methodsFor: 'delegation' stamp: 'mb 10/13/2006 14:21'!
templateSourceCode
	^self main templateSourceCode! !

WAClassBrowserPane subclass: #WAClassBrowserRightPane
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAClassBrowserRightPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:27'!
renderContentOn: html 
	self renderProtocolsOn: html.
	self renderSelectorsOn: html.! !

!WAClassBrowserRightPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:56'!
renderProtocolsListOn: html 
	(html select)
		size: self listSize;
		id: 'protocolList';
		selected: self protocol;
		list: self protocols;
		liveCallback:
			[:value :renderer |
			main selectProtocol: value on: renderer]! !

!WAClassBrowserRightPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:51'!
renderProtocolsOn: html 
	(html div)
		id: 'protocols';
		with: [ self renderProtocolsListOn: html ].! !

!WAClassBrowserRightPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:56'!
renderSelectorsListOn: html 
	(html select)
		size: self listSize;
		id: 'selectorList';
		selected: self selector;
		list: self selectors;
		liveCallback:
			[:value :renderer |
			main selectSelector: value on: renderer]! !

!WAClassBrowserRightPane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:52'!
renderSelectorsOn: html 
	(html div)
		id: 'selectors';
		with: [ self renderSelectorsListOn: html ]! !

WAClassBrowserPane subclass: #WAClassBrowserSourcePane
	instanceVariableNames: 'sourceCode'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAClassBrowserSourcePane methodsFor: 'button text' stamp: 'mb 10/18/2006 14:22'!
removeButtonText
	^'Remove this ' , self main removeText , ' (Ctrl-X)'! !

!WAClassBrowserSourcePane methodsFor: 'button text' stamp: 'mb 10/18/2006 14:26'!
renameButtonText
	^'Rename this ' , self main renameText , ' (Ctrl-R)'! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:42'!
renderContentOn: html 
	self renderSourceOn: html! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 10/13/2006 16:04'!
renderMessageOn: html 
	main message notNil 
		ifTrue: 
			[(html div)
				id: 'message';
				with: main message]
		ifFalse: 
			[(html div)
				id: 'title';
				with: self sourceTitle]! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 7/9/2007 07:27'!
renderReadOnlySourceOn: html 
	| stream lines |
	lines := OrderedCollection new.
	stream := sourceCode readStream.
	[stream atEnd]
		whileFalse: [lines add: stream nextLine].
	lines := lines readStream.
	html strong: lines next.
	[lines atEnd]
		whileFalse: [html break.
			stream := lines next readStream.
			[stream atEnd]
				whileFalse: [stream peek == Character tab
						ifTrue: [html space: 3.
							stream next]
						ifFalse: [html text: stream upToEnd]]]! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 10/18/2006 14:19'!
renderRemoveButtonOn: html 
	self canRemoveSourceCode ifTrue:
		[(html submitButton)
			addShortcut: 'Ctrl-X';
			addShortcut: 'Ctrl-x';
			callback: [main removeSourceCode];
			text: self removeButtonText]! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 10/18/2006 14:31'!
renderRenameButtonOn: html 
	self canRenameSourceCode ifTrue:
		[(html submitButton)
			addShortcut: 'Ctrl-R';
			addShortcut: 'Ctrl-r';
			callback: [main renameSourceCode];
			text: self renameButtonText]! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 10/13/2006 18:22'!
renderSaveButtonOn: html 
	self canSaveSourceCode ifTrue:
		[(html submitButton)
			addShortcut: 'Ctrl-S';
			addShortcut: 'Ctrl-s';
			callback: [main saveSourceCode: sourceCode];
			text: 'Accept (Ctrl-S)']! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:42'!
renderSourceCodeOn: html 
	sourceCode := self sourceCode ifNil: [^html space].
	self isReadOnly ifTrue: [^self renderReadOnlySourceOn: html].
	self renderMessageOn: html.
	html form: 
			[(html textArea)
				id: #contents;
				callback: [:v | sourceCode := v];
				value: sourceCode.
			self renderSaveButtonOn: html.
			self renderRenameButtonOn: html.
			self renderRemoveButtonOn: html.]
! !

!WAClassBrowserSourcePane methodsFor: 'rendering' stamp: 'mb 11/6/2006 09:43'!
renderSourceOn: html 
	(html div)
		id: 'source';
		with: [self renderSourceCodeOn: html]! !

!WAClassBrowserSourcePane methodsFor: 'button text' stamp: 'mb 10/18/2006 14:20'!
saveButtonText
	^'Accept (Ctrl-S)'! !

WAAsyncComponent subclass: #WAFullClassBrowser
	instanceVariableNames: 'leftComponents left rightComponents right bottom isReadOnly message browser contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAFullClassBrowser class methodsFor: 'testing' stamp: 'mb 10/13/2006 12:52'!
canBeRoot
	^true! !

!WAFullClassBrowser class methodsFor: 'accessing' stamp: 'mb 11/6/2006 09:01'!
description
	^'Ajax Smalltalk class browser (four panes)'! !

!WAFullClassBrowser class methodsFor: 'instance creation' stamp: 'mb 11/6/2006 08:59'!
fullOnClass: aClass
	^self fullOnClass: aClass selector: nil! !

!WAFullClassBrowser class methodsFor: 'instance creation' stamp: 'mb 11/6/2006 08:58'!
fullOnClass: aClass selector: aSelector
	^(self new)
		setClass: aClass selector: aSelector;
		yourself! !

!WAFullClassBrowser class methodsFor: 'class initialization' stamp: 'mb 11/6/2006 09:00'!
initialize
	self registerAsApplication: 'tools/classbrowser'! !

!WAFullClassBrowser methodsFor: 'browser callbacks' stamp: 'mb 11/6/2006 08:47'!
bindingOf: aString
	"Here when an unknown variable is used in a method"
	(WAUnknownVariable new)
		varName: aString;
		signal! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
bottom
	"Answer the value of bottom"

	^ bottom! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
bottom: anObject
	"Set the value of bottom"

	bottom := anObject! !

!WAFullClassBrowser methodsFor: 'navigation' stamp: 'mb 10/13/2006 17:18'!
bottomComponent
	^bottom
		main: self;
		yourself! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
browser
	"Answer the value of browser"

	^ browser! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
browser: anObject
	"Set the value of browser"

	browser := anObject! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 18:42'!
canRemoveSourceCode
	"May remove classes with this tool"
	^self selectedClass notNil.! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/18/2006 16:10'!
canRenameSourceCode
	"May rename a method category"
	^self protocol notNil.! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 18:37'!
canSaveSourceCode
	"Can save new classes with this tool"
	^self package notNil! !

!WAFullClassBrowser methodsFor: 'rendering' stamp: 'mb 10/13/2006 17:20'!
children
	^Array 
		with: self leftComponent
		with: self rightComponent
		with: self bottomComponent! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:09'!
classes
	^self browser classList! !

!WAFullClassBrowser methodsFor: 'lightbox' stamp: 'RJT 5/8/2007 12:26'!
confirm: aString
	^self lightbox: (WAYesOrNoDialog new addMessage: aString; yourself)! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
contents
	"Answer the value of contents"

	^ contents! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
contents: anObject
	"Set the value of contents"

	contents := anObject! !

!WAFullClassBrowser methodsFor: 'lightbox' stamp: 'RJT 5/8/2007 12:26'!
inform: aString
	self lightbox: (WAFormDialog new addMessage: aString; yourself)! !

!WAFullClassBrowser methodsFor: 'initialize-release' stamp: 'mb 11/6/2006 10:09'!
initialRequest: aRequest
	| theClass |
	aRequest fields at: 'class' ifPresent:
		[:className | 
		Smalltalk at: className asSymbol ifPresent:
			[:class |
			theClass := (aRequest fields includesKey: 'meta')
					ifTrue: [class class]
					ifFalse: [class].
			self setClass: theClass selector: nil.
			aRequest fields at: 'method' ifPresent:
				[:selector |
				self setClass: theClass selector: selector asSymbol]]]! !

!WAFullClassBrowser methodsFor: 'initialize-release' stamp: 'mb 11/6/2006 08:55'!
initialize
	super initialize.
	self browser: WAPermissiveBrowser new.
	self browser component: self.
	self browser addDependent: self.
	self contents: self browser contents.
	isReadOnly := false.
	leftComponents := (Dictionary new)
				at: 'Categories' put: WAClassBrowserLeftPane new;
				yourself.
	self left: 'Categories'.
	rightComponents := (Dictionary new)
				at: 'Instance' put: WAClassBrowserRightPane new;
				at: 'Class' put: WAClassBrowserRightPane new;
				yourself.
	self right: 'Instance'.
	bottom := WAClassBrowserSourcePane new.! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
isReadOnly
	"Answer the value of isReadOnly"

	^ isReadOnly! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
isReadOnly: anObject
	"Set the value of isReadOnly"

	isReadOnly := anObject! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
left
	"Answer the value of left"

	^ left! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
left: anObject
	"Set the value of left"

	left := anObject! !

!WAFullClassBrowser methodsFor: 'navigation' stamp: 'mb 10/13/2006 18:10'!
leftComponent
	^(leftComponents at: self left)
		main: self;
		componentName: self left;
		yourself! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
leftComponents
	"Answer the value of leftComponents"

	^ leftComponents! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
leftComponents: anObject
	"Set the value of leftComponents"

	leftComponents := anObject! !

!WAFullClassBrowser methodsFor: 'navigation' stamp: 'mb 10/13/2006 17:18'!
leftOptions
	^leftComponents keys! !

!WAFullClassBrowser methodsFor: 'lightbox' stamp: 'mb 11/6/2006 12:55'!
lightbox: aComponent
	^(self class superclass canUnderstand: #lightbox:) ifTrue:
		[super lightbox: (aComponent addDecoration: WAClassBrowserDialogDecoration new; yourself)]
	ifFalse:
		[self call: aComponent].! !

!WAFullClassBrowser methodsFor: 'constants' stamp: 'mb 10/13/2006 17:08'!
listSize
	^15! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
message
	"Answer the value of message"

	^ message! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
message: anObject
	"Set the value of message"

	message := anObject! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 11/21/2006 14:30'!
model
	"Polymorphism with WABrowser"
	^self browser! !

!WAFullClassBrowser methodsFor: 'browser callbacks' stamp: 'mb 10/13/2006 17:10'!
notify: aString at: location in: sourceStream
	"Here when there was a compile error"
	message := aString allButLast: 3! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:11'!
package
	self browser systemCategoryListIndex = 0 ifTrue: [^nil].
	^self packages at: self browser systemCategoryListIndex! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:11'!
package: anObject
	^self browser systemCategoryListIndex: (self packages indexOf: anObject)! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:11'!
packages
	^self browser systemCategoryList! !

!WAFullClassBrowser methodsFor: 'private' stamp: 'mb 11/6/2006 09:33'!
pause
	"Activate this code to demo ajax interactivity"
	"(Delay forSeconds: 1) wait."! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:11'!
protocol
	self browser messageCategoryListIndex = 0 ifTrue: [^nil].
	^self protocols at: self browser messageCategoryListIndex! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:11'!
protocol: anObject
	^self browser messageCategoryListIndex: (self protocols indexOf: anObject)! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:12'!
protocols
	^self browser messageCategoryList! !

!WAFullClassBrowser methodsFor: 'actions' stamp: 'mb 10/13/2006 18:44'!
removeSourceCode
	self selector notNil
		ifTrue: [^self browser removeMessage].
	self protocol notNil
		ifTrue: [^self browser removeMessageCategory].
	self selectedClass notNil
		ifTrue: [^self browser removeClass].
! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/18/2006 14:22'!
removeText
	self selector notNil
		ifTrue: [^'method'].
	self protocol notNil
		ifTrue: [^'method category'].
	self selectedClass notNil
		ifTrue: [^'class'].
! !

!WAFullClassBrowser methodsFor: 'actions' stamp: 'mb 10/18/2006 14:32'!
renameSourceCode
	^self browser renameCategory! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/18/2006 14:27'!
renameText
	self protocol notNil
		ifTrue: [^'method category'].
! !

!WAFullClassBrowser methodsFor: 'rendering' stamp: 'mb 10/13/2006 17:23'!
renderContentOn: html
	(html div)
		id: 'class-browser';
		with: 
			[(html div)
				id: 'left';
				with: 
					[(html div)
						class: 'nav-options';
						id: 'left-options';
						with: [self renderLeftOptionsOn: html].
					html render: self leftComponent].
			(html div)
				id: 'right';
				with: 
					[(html div)
						class: 'nav-options';
						id: 'right-options';
						with: [self renderRightOptionsOn: html].
					html render: self rightComponent].	
		html div class: 'clear'.
		html render: self bottomComponent].! !

!WAFullClassBrowser methodsFor: 'rendering' stamp: 'mb 10/13/2006 18:10'!
renderLeftOptionsOn: html 
	(html unorderedList)
		list: self leftOptions;
		selected: self left;
		callback: [:v | self left: v]! !

!WAFullClassBrowser methodsFor: 'rendering' stamp: 'mb 10/13/2006 18:11'!
renderRightOptionsOn: html 
	(html unorderedList)
		list: self rightOptions;
		selected: self right;
		callback: [:v | self right: v]! !

!WAFullClassBrowser methodsFor: 'lightbox' stamp: 'RJT 5/8/2007 12:26'!
request: requestString label: labelString default: initialString
	^ self lightbox:
		((WAInputDialog new
			label: labelString;
			default: initialString;
			yourself)
				addMessage: requestString; yourself)! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
right
	"Answer the value of right"

	^ right! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 18:11'!
right: anObject
	"Set the value of right"

	right := anObject.
	self right = 'Class' 
		ifTrue: [self browser indicateClassMessages]
		ifFalse: [self browser indicateInstanceMessages].
! !

!WAFullClassBrowser methodsFor: 'navigation' stamp: 'mb 10/13/2006 18:09'!
rightComponent
	^(rightComponents at: self right)
		main: self;
		componentName: self right;
		yourself! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
rightComponents
	"Answer the value of rightComponents"

	^ rightComponents! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 16:08'!
rightComponents: anObject
	"Set the value of rightComponents"

	rightComponents := anObject! !

!WAFullClassBrowser methodsFor: 'navigation' stamp: 'mb 10/13/2006 17:18'!
rightOptions
	^rightComponents keys! !

!WAFullClassBrowser methodsFor: 'actions' stamp: 'mb 11/6/2006 08:47'!
saveSourceCode: aString 
	| saveProtocol saveSelector saveMessage |
	SeasidePlatformSupport ensureAuthorInitials: [self request: 'Please enter your initials:'].
	message := nil.
	saveProtocol := self protocol.
	saveSelector := self selector.
	[self browser contents: aString notifying: self]
		on: WAUnknownVariable
		do: [:error | message := error messageText].
	saveMessage := message.
	self protocol: saveProtocol.
	self selector: saveSelector.
	self contents: aString.
	message := saveMessage! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:55'!
selectClass: aClass on: aRenderer
	self selectedClass: aClass.
	self updateProtocolsOn: aRenderer.
! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:47'!
selectPackage: aPackage on: aRenderer
	self package: aPackage.
	self updateClassesOn: aRenderer.
! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:50'!
selectProtocol: aProtocol on: aRenderer
	self protocol: aProtocol.
	self updateSelectorsOn: aRenderer.
! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:53'!
selectSelector: aSelector on: aRenderer
	self selector: aSelector.
	self updateSourceOn: aRenderer.
! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:12'!
selectedClass
	self browser classListIndex = 0 ifTrue: [^nil].
	^self classes at: self browser classListIndex! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:12'!
selectedClass: anObject
	^self browser classListIndex: (self classes indexOf: anObject)! !

!WAFullClassBrowser methodsFor: 'browser callbacks' stamp: 'mb 10/18/2006 15:44'!
selectionInterval
	^1 to: 1! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:13'!
selector
	self browser messageListIndex = 0 ifTrue: [^nil].
	^self selectors at: self browser messageListIndex! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:13'!
selector: anObject
	^self browser messageListIndex: (self selectors indexOf: anObject)! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:39'!
selectors
	self protocol isNil ifTrue: [^Array new].
	^self browser messageList! !

!WAFullClassBrowser methodsFor: 'initialize-release' stamp: 'mb 11/6/2006 10:08'!
setClass: aClass selector: aSymbol
	self browser setClass: aClass selector: aSymbol.! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:13'!
sourceCode
	^self contents! !

!WAFullClassBrowser methodsFor: 'model' stamp: 'mb 10/13/2006 17:57'!
sourceTitle
	self selector notNil 
		ifTrue: [^self selectedClass asString , ' >> ' , self selector].
	self protocol notNil 
		ifTrue: [^self selectedClass asString , ' >> template for new method'].
	self selectedClass notNil 
		ifTrue: [^self selectedClass asString , ' class definition'].
	self package notNil
		ifTrue: [^'Template for new class definition'].
	^nil! !

!WAFullClassBrowser methodsFor: 'rendering' stamp: 'mb 11/19/2006 15:10'!
style
	^ '
div#class-browser {
	font-family: Verdana;
}
div#left, div#right {
	float: left;
	width: 49.9%;
}
div#packages, div#classes, div#protocols, div#selectors {
	float: left;
	width: 49.9%;
}
div.clear {
	clear: both;
	height: 1em;
}
div#packages select, div#classes select, div#protocols select, div#selectors select {
	width: 100%;
}
div#source {
	padding: 1em;
	border: 1px solid #dddddd;
	background-color: #f5f5f5;
}
textarea#contents {
	width: 100%;
	height: 20em;
	margin-top: 1em;
	margin-bottom: 1em;
}
div#message, div#title {
	font-weight: bold;
}
div#message {
	color: red;
}


div.nav-options {
	border-bottom : 1px solid #ccc;
	margin : 0;
	padding-bottom : 19px;
	padding-left : 10px;
}
div.nav-options ul, div.nav-options li	{
	display : inline;
	list-style-type : none;
	margin : 0;
	padding : 0;
}
div.nav-options a:link, div.nav-options a:visited	{
	background : #E8EBF0;
	border : 1px solid #ccc;
	color : #666;
	float : left;
	font-size : small;
	font-weight : normal;
	line-height : 14px;
	margin-right : 8px;
	padding : 2px 10px 2px 10px;
	text-decoration : none;
}

div.nav-options a:link.active, div.nav-options a:visited.active	{
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}

div.nav-options ul a:hover	{
	color : #f00;
}

div.nav-options .option-selected a {
	background : #fff;
	border-bottom : 1px solid #fff;
	color : #000;
}


'! !

!WAFullClassBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 18:18'!
text
	^ Text fromString: ''! !

!WAFullClassBrowser methodsFor: 'browser callbacks' stamp: 'mb 10/18/2006 15:20'!
update: aSymbol
	aSymbol == #contents ifTrue:
		["Here when the source pane has changed"
		message := nil.
		self contents: self browser contents]
! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:31'!
updateClassesOn: html 
	self pause.
	self leftComponent renderClassesOn: html.
	self updateProtocolsOn: html.! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:31'!
updateProtocolsOn: html 
	self pause.
	self rightComponent renderProtocolsOn: html.
	self updateSelectorsOn: html.
! !

!WAFullClassBrowser methodsFor: 'rendering' stamp: 'mb 7/9/2007 07:43'!
updateRoot: anHtmlRoot 
	super updateRoot: anHtmlRoot.
	(self session application libraries includes: WAAsyncScripts)
		ifFalse: [WAAsyncScripts default updateRoot: anHtmlRoot]! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 11/6/2006 09:31'!
updateSelectorsOn: html 
	self pause.
	self rightComponent renderSelectorsOn: html.
	self updateSourceOn: html.! !

!WAFullClassBrowser methodsFor: 'ajax updates' stamp: 'mb 10/13/2006 17:26'!
updateSourceOn: html 
	self pause.
	self bottomComponent renderSourceOn: html.! !

Object subclass: #WALiveEvent
	instanceVariableNames: 'type when elementTagName elementId elementValue elementType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Rendering'!

!WALiveEvent class methodsFor: 'instance creation' stamp: 'mb 7/6/2007 16:18'!
newFromRequest: aRequest
	^self new fromRequest: aRequest! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:54'!
elementId
	^ elementId! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 7/6/2007 16:32'!
elementId: aString
	elementId := aString! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:53'!
elementTagName
	^ elementTagName! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 7/6/2007 16:32'!
elementTagName: aString
	elementTagName := aString! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:54'!
elementType
	^ elementType! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 7/6/2007 16:33'!
elementType: aString
	elementType := aString! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:54'!
elementValue
	^ elementValue! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 7/6/2007 16:33'!
elementValue: anObject
	elementValue := anObject! !

!WALiveEvent methodsFor: 'initialization' stamp: 'mb 7/6/2007 16:19'!
fromRequest: aRequest 
	aRequest isLiveRequest
		ifFalse: [^ self error: 'Not a live request'].
	when := aRequest at: 'timestamp'.
	(aRequest includesKey: 's')
		ifTrue: ["Live callback"
			elementValue := aRequest at: 's'].
	(aRequest includesKey: 'ms')
		ifTrue: ["Live callback multi-select"
			elementValue := (aRequest at: 'ms')
						findTokens: ','].
	(aRequest includesKey: 'eventType')
		ifTrue: ["Event tracking"
			type := aRequest at: 'eventType'.
			elementType := aRequest at: 'targetType'.
			elementTagName := aRequest at: 'tagName'.
			elementId := aRequest at: 'id'.
			elementValue := aRequest at: 'targetValue']! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:54'!
type
	^ type! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 7/6/2007 16:34'!
type: aString
	type := aString! !

!WALiveEvent methodsFor: 'services' stamp: 'mb 3/30/2006 16:29'!
value
	type = 'check' ifTrue: [^self valueAsBoolean].
	^elementValue.! !

!WALiveEvent methodsFor: 'services' stamp: 'mb 3/30/2006 16:29'!
valueAsBoolean
	^elementValue = 'true'! !

!WALiveEvent methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:54'!
when
	^ when! !

!WAAnchorTag methodsFor: '*seasideasync' stamp: 'mb 7/6/2007 15:32'!
liveCallback: liveBlock
	liveBlock fixCallbackTemps.
	self onClickCallback: [:event :h | liveBlock value: h].
	self onClick: 'return false'
! !

Browser subclass: #WAPermissiveBrowser
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAPermissiveBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 19:59'!
component
	^ component! !

!WAPermissiveBrowser methodsFor: 'accessing' stamp: 'mb 10/13/2006 19:59'!
component: anObject
	component := anObject! !

!WAPermissiveBrowser methodsFor: 'confirm' stamp: 'mb 10/13/2006 18:48'!
confirm: aString
	^self component confirm: aString! !

!WAPermissiveBrowser methodsFor: 'confirm' stamp: 'mb 10/18/2006 15:36'!
confirmRemovalOf: aSelector on: aClass
	^1! !

!WAPermissiveBrowser methodsFor: 'confirm' stamp: 'mb 10/18/2006 14:37'!
request: aString initialAnswer: anotherString
	^self component request: aString default: anotherString! !

!WAPermissiveBrowser methodsFor: 'accessing' stamp: 'mb 10/18/2006 15:35'!
systemNavigation
	! !

!WAHtmlRoot methodsFor: '*seasideasync' stamp: 'mb 7/6/2007 16:49'!
scripts
	^ scripts! !

WAHtmlRoot subclass: #WAXmlRoot
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Rendering'!

!WAXmlRoot methodsFor: 'constants' stamp: 'mb 3/30/2006 13:06'!
contentType
	^'text/xml'! !

!WAXmlRoot methodsFor: 'constants' stamp: 'mb 7/6/2007 17:54'!
writeHeadOn: aDocument 
	aDocument nextPutAll: '<?xml version="1.0" encoding="';
		 nextPutAll: WACurrentSession value charSet;
		 nextPutAll: '"?>'.
	aDocument openTag: 'body' attributes: bodyAttrs.! !

WADateInput subclass: #WALiveDateInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Renderers'!

!WALiveDateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:26'!
addDayCallbackToBrush: aBrush
	super addDayCallbackToBrush: aBrush.
	self hasLiveCallback ifFalse: [^self].
	aBrush liveCallback:
		[:d :renderer |
		self day: d.
		self liveCallback value: self setValueWithNewDate value: renderer].


! !

!WALiveDateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:26'!
addMonthCallbackToBrush: aBrush
	super addMonthCallbackToBrush: aBrush.
	self hasLiveCallback ifFalse: [^self].
	aBrush liveCallback:
		[:m :renderer |
		self month: m.
		self liveCallback value: self setValueWithNewDate value: renderer].

! !

!WALiveDateInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 14:26'!
addYearCallbackToBrush: aBrush
	super addYearCallbackToBrush: aBrush.
	self hasLiveCallback ifFalse: [^self].
	aBrush liveCallback:
		[:y :renderer |
		self year: y.
		self liveCallback value: self setValueWithNewDate value: renderer].

! !

Error subclass: #WAUnknownVariable
	instanceVariableNames: 'varName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Browser'!

!WAUnknownVariable methodsFor: 'accessing' stamp: 'mb 10/18/2006 15:18'!
messageText
	"Return an exception's message text."

	^'Undefined variable ' , varName printString! !

!WAUnknownVariable methodsFor: 'accessing' stamp: 'mb 10/18/2006 15:12'!
varName
	"Answer the value of varName"

	^ varName! !

!WAUnknownVariable methodsFor: 'accessing' stamp: 'mb 10/18/2006 15:12'!
varName: anObject
	"Set the value of varName"

	varName := anObject! !

!WARadioButtonTag methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 18:58'!
liveCallback: liveBlock
	| uri id |
	id := self ensureId.
	liveBlock fixCallbackTemps.
	uri := canvas urlForLiveAction: 
		[:event :h | liveBlock 
			value: event valueAsBoolean
			value: h].
	self session 
		addLoadScript: 
			'document.getElementById('
				, id asString printString
				, ').onclick = liveCheck(' 
				, id asString printString
				, ','
				, (canvas encode: uri asString) printString
				, ')'
! !

!WARequest methodsFor: '*SeasideAsync' stamp: 'mb 11/21/2006 14:38'!
isLiveRequest
	^ (self headerAt: 'x-requested-by') = 'SeasideAsync'! !

WATimeInput subclass: #WALiveTimeInput
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Renderers'!

!WALiveTimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 17:57'!
addHoursCallbackToBrush: aBrush
	super addHoursCallbackToBrush: aBrush.
	self hasLiveCallback ifFalse: [^self].
	aBrush liveCallback:
		[:h :renderer |
		self hours: h.
		self liveCallback value: self setValueWithNewTime value: renderer].

! !

!WALiveTimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 17:57'!
addMinutesCallbackToBrush: aBrush
	super addMinutesCallbackToBrush: aBrush.
	self hasLiveCallback ifFalse: [^self].
	aBrush liveCallback:
		[:m :renderer |
		self minutes: m.
		self liveCallback value: self setValueWithNewTime value: renderer].



! !

!WALiveTimeInput methodsFor: 'private callbacks' stamp: 'mb 11/3/2006 17:57'!
addSecondsCallbackToBrush: aBrush
	super addSecondsCallbackToBrush: aBrush.
	self hasLiveCallback ifFalse: [^self].
	aBrush liveCallback:
		[:s :renderer |
		self seconds: s.
		self liveCallback value: self setValueWithNewTime value: renderer].


! !

!WACompound methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 14:25'!
hasLiveCallback
	^self liveCallback notNil! !

!WACompound methodsFor: '*seasideasync' stamp: 'mb 11/3/2006 10:31'!
liveCallback
	^properties at: #liveCallback ifAbsent: [nil]! !

!WACompound methodsFor: '*seasideasync' stamp: 'mb 7/6/2007 15:33'!
liveCallback: liveBlock 
	liveBlock fixCallbackTemps.
	properties at: #liveCallback put: liveBlock! !

!WACallbackRegistry methodsFor: '*seasideasync' stamp: 'mb 3/21/2006 14:10'!
registerLiveActionCallback: aBlock renderer: aRenderer
	^self storeCallback: (WALiveActionCallback new
		block: aBlock;
		rendererClass: aRenderer class;
		callbacks: self)! !

SeasideAddonVWInfo subclass: #SeasideAsyncVWInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Platform'!

!SeasideAsyncVWInfo class methodsFor: 'accessing' stamp: 'mb 1/29/2007 10:50'!
addonName
	^'SeasideAsync'! !

!SeasideAsyncVWInfo methodsFor: 'accessing' stamp: 'mb 7/6/2007 16:41'!
packageName
	^ self addonName! !

!WASubmitButtonTag methodsFor: '*seasideasync' stamp: 'mb 7/6/2007 15:33'!
liveCallback: liveBlock 
	liveBlock fixCallbackTemps.
	self
		onClickCallback: [:event :h | liveBlock value: h].
	self onClick: 'return false'! !

WAFileLibrary subclass: #WAAsyncScripts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Libraries'!

!WAAsyncScripts class methodsFor: 'processing' stamp: 'mb 3/13/2007 18:25'!
updateRoot: anHtmlRoot
	"This method is not supplied by superclass in Seaside 2.7"
	self new
		do: [:ea | anHtmlRoot addScript: ea]! !

!WAAsyncScripts methodsFor: 'scripts' stamp: 'mb 5/3/2007 13:25'!
ajaxJs
	^ '

var requests = [];

function liveUpdater(uriFunc, ret)
{
	function xmlUpdater()
	{
		return sendHttpCallback(uriFunc(), ret);
	}
	return xmlUpdater;

	//	Build and send HTTP request to Seaside

	function sendHttpCallback(uri, ret, respFunc)
	{
		var request = newHttpRequest();
		if (!!request)
			return ret;
		if (!!respFunc)
			respFunc = processRequestChange;
		request.onreadystatechange = respFunc;
		// Resolve xml entity before issuing the request
		var uri = addParameter(uri, "timestamp", (new Date()).getTime().toString());
		var regex = new RegExp("&amp;", "g");
		uri = uri.replace(regex,"&");
		request.open("GET", uri, true);
		setRequestHeaders(request);
		request.send(null);
		requests[requests.length] = request;
		// debug("GET " + uri);
		// debug ("Pending " + requests.length);
		return ret;
	}
}


//	Process state change of HTTP requests

function processRequestChange()
	{
		var pendingRequests = [];
		for ( var rx = 1 ; rx <= requests.length ; rx++ ) {
			var request = requests[rx-1];
			if (request.readyState == 4) {
				if (request.responseText.length > 51) handleLiveResponse(request);
			} else {
				pendingRequests[pendingRequests.length] = request;
			}
		}
		if (requests.length !!= pendingRequests.length) {
			requests = pendingRequests
			// debug ("Pending " + requests.length);
		}
	}


//	Parse HTTP response from the Seaside live callbacks as XML and update the document

function handleLiveResponse(request)
	{	
		var doc = request.responseXML;
		var replacements = [];
		var anyReplacement = false;
		var anyScriptEvaluated = false;
		// debug("HTTP status " + request.status + " " + request.statusText);
		// debug(request.responseText);			
		// debug(request.getAllResponseHeaders() );	
		if (doc !!= null) {
			var elements = doc.getElementsByTagName("*");
			if (elements.length == 0) {
				// IE does not support the above, use an alternative hard-coded technique
				elements = getAllElements(doc)
			}
			// Find html elements with the id= attribute
			for ( var x = 1 ; x <= elements.length ; x++ ) {
				var elem = elements[x-1];
				if (elem.tagName == "body") {
					var body = xmlString(elem);
				}
				var attributes = elem.attributes;
				if (attributes.length > 0) {
					for ( var ax = 1 ; ax <= attributes.length ; ax++ ) {
						var attr = attributes[ax-1];
						var attrName = attr.name;
						if (attrName == "id") {
							// Find the html element in the document that has a matching id and replace it
							var docElement = document.getElementById(attr.value);
							if (docElement) {
								if (!!includes(replacements,elem)) {
									// HTML is only updated with the parent at highest level
									// Resolve IE and Opera issue where <br></br> skips two lines
									var regex = new RegExp("<br></br>", "g");
									var replacement = xmlString(elem).replace(regex,"<br/>");
									try {
										docElement.innerHTML = replacement;
										anyReplacement = true;
										replacements[replacements.length] = attr.value;
									} catch (e) {
										// Some browsers (like Safari) have read-only elements
										// IE does not allow form elements for innerHTML
									}
								}
							}
						}
					}
				}   
			}
			// Find html <script> elements and execute them
			for ( var x = 1 ; x <= elements.length ; x++ ) {
				var elem = elements[x-1];
				if (elem.tagName == ''script'') {
					// debug("About to evaluate script");
					// debug(xmlString(elem));
					eval(xmlString(elem));
					// debug("Evaluated");
					anyScriptEvaluated = true;
				}
			}
		}
		if (!!anyReplacement & !!anyScriptEvaluated) {
			if ( body ) {
				// Here when XML could be parsed but was unproductive
				// Most probable reason : a bug in the live callback code
				alert("No replacement and no script evaluated, probable bug in your callback code.\n\n"
					+ "See below the response produced by the callback code.\n\n"
					+ request.responseText);
				// document.body.innerHTML = body;
			} else {
				// Here when XML could not be parsed
				// Most probable reason : response does not have an xml content
				// For instance : an exception in the live callback
				// So we replace the whole page with the whole response
				try {
					if (!!request.responseText.length == 0) {
						document.body.innerHTML = request.responseText;
					} else {
						debug("HTTP code " + request.status + " " + request.statusText
									+ " with no text in response!!");
					}	
				} catch (e) {
					// In some cases of concurrency
					// readyState is 4, but there status is not available
					debug("HTTP response status not available although readyState is 4!!");
					debug(request.responseText);	
				}					
			}
		}
	}

'! !

!WAAsyncScripts methodsFor: 'scripts' stamp: 'mb 5/3/2007 13:26'!
eventTrackingJs
	^ '
var eventRequests = [];

function liveEventTrackerUri(event, uri)
{
	var target = (event.target) ? event.target : event.srcElement;
	var type = target.type;
	var value = target.value;
	if (type == "radio") value = target.checked;
	if (type == "checkbox") value = (value == "on");
	uri = addParameter(uri, "timestamp", (new Date()).getTime().toString());
	uri = addParameter(uri, "eventType", event.type);
	uri = addParameter(uri, "targetValue", value);
	uri = addParameter(uri, "targetType", type);
	uri = addParameter(uri, "tagName", target.tagName);
	uri = addParameter(uri, "id", target.id);
//	Cursor position ?
	var request = newHttpRequest();
	if (!!request) return false;
	request.onreadystatechange = processEventTracker;
	// Resolve xml entity before issuing the request
	var regex = new RegExp("&amp;", "g");
	uri = uri.replace(regex,"&");
	request.open("GET", uri, true);
	setRequestHeaders(request);
	request.send(null);
	eventRequests[eventRequests.length] = request;
	return false;
}

//	Process state change of HTTP requests

function processEventTracker()
{
	var pendingEvents = [];
	for ( var rx = 1 ; rx <= eventRequests.length ; rx++ ) {
		var request = eventRequests[rx-1];
		if (request.readyState == 4) {
			// debug (request.responseText);
			var doc = request.responseXML;
			var body = doc.getElementsByTagName("body")[0];
			// Discard empty responses
			if (body.childNodes.length > 0) handleLiveResponse(request);
		} else {
			pendingEvents[pendingEvents.length] = request;
		}
	}
	if (eventRequests.length !!= pendingEvents.length) {
		eventRequests = pendingEvents;
		// debug ("Pending events " + eventRequests.length);
	}
}

'! !

!WAAsyncScripts methodsFor: 'scripts' stamp: 'mb 5/3/2007 13:26'!
liveUpdateJs
	^ '

	var nav;
	if (navigator.userAgent.indexOf("Safari") > 0)
			nav = "Safari";
	else if (navigator.product == "Gecko")
			nav = "Gecko";
	else
			nav = "IE";

function liveUpdaterUri(uri)
{
	return liveUpdater(function() { return uri; } , false);
}

// Selection in a list box possibly with multiple selections, add the selected indexes to the callback
function liveSelect(id, uri)
{
	function constructUri()
	{

		var indexes = [];
		var options = document.getElementById(id).options;
		for ( var x = 1 ; x <= options.length ;  x++ ) {
			if (options[x-1].selected) indexes[indexes.length+1] = x;
		}
		return addParameter(uri, "ms", indexes.toString());
	}
	return liveUpdater(constructUri, false);
}

// Key stroke in an entry field, add the field value to the callback
function liveSearch(id, uri)
{
	function constructUri()
	{
		return addParameter(uri, "s", document.getElementById(id).value);
	}

   	var updater = liveUpdater(constructUri, false);
	var last = document.getElementById(id).value;
	var timeout = false;
  
	function update()
	{
		if (last !!= document.getElementById(id).value) {
			last = document.getElementById(id).value;
			updater();
		}
	}
	   
	function start() {
		if (timeout)
			window.clearTimeout(timeout);
		timeout = window.setTimeout(update, 300);
	}

	if (navigator.userAgent.indexOf("Safari") > 0)
		document.getElementById(id).addEventListener("keydown",start,false);
	else if (navigator.product == "Gecko")
		document.getElementById(id).addEventListener("keypress",start,false);
	else
		document.getElementById(id).attachEvent("onkeydown",start);
}

// Click
function liveClick(id, uri)
{
	return liveUpdaterUri(uri);
}

// Click in a checkbox
function liveCheck(id, uri)
{
	function constructUri()
	{
		return addParameter(uri, "s", document.getElementById(id).checked);
	}
	return liveUpdater(constructUri);
}

function liveScroll(id, uri)
{
   function constructUri()
   {
         return addParameter(uri, "s", document.getElementById(id).scrollTop.toString());
   }
   
   var updater = liveUpdater(constructUri, false);
   var timeout = false;

    function start() {
	   if (timeout)
	       window.clearTimeout(timeout);
	   
    	   timeout = window.setTimeout(updater, 100);
    }
   return start;
}

function timedUpdate(uri, milliSeconds)
{
	var updater = liveUpdaterUri(uri, false);
	updater();
	var again = "timedUpdate(\""+uri+"\","+milliSeconds+")";
	setTimeout(again, milliSeconds);
}
'! !

!WAAsyncScripts methodsFor: 'scripts' stamp: 'mb 6/5/2007 17:36'!
liveUpdateUtilitiesJs
	^'
function addParameter(uri, key, value)
{
	// See http://xkr.us/articles/javascript/encode-compare/
	var separator = "?";
	if (uri.indexOf("?") >= 0)
		separator = "&";
	return uri + separator + key + "=" + encodeURIComponent(value);
}

// Function below to instantiate an XMLHttpRequest object
// Credits: http://jibbering.com/2002/4/httprequest.html
// Credits: http://www.toutjavascript.com/savoir/xmlhttprequest.php3
function newHttpRequest()
{
	var httpRequest = false;
	if(window.XMLHttpRequest)
		// Firefox, Mozilla, Safari
		httpRequest = new XMLHttpRequest();
	else if(window.ActiveXObject) 
		// Internet Explorer
		{	try {  
 				httpRequest = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (e) {
  				try {
   					httpRequest = new ActiveXObject("Msxml2.XMLHTTP");
				} catch (E) {
					httpRequest = false;
 	 			}
			}
		}
	return httpRequest;
}

function setRequestHeaders(request)
{
	request.setRequestHeader("X-Requested-With","XMLHttpRequest");
	request.setRequestHeader("X-Requested-By","SeasideAsync");
	request.setRequestHeader("Accept","text/html, application/xml, text/xml, */*");
}

// Functions below to rebuild the xml string of an element
function xmlString (element) {
	var xml = "";
	for ( var x = 1 ; x <= element.childNodes.length ;  x++ ) {
		var node = element.childNodes[x-1];
		xml += outerXmlString(node);
	}
	return xml;
}
function outerXmlString (element) {
	if (!!element.tagName) {
		var elementData = element.data;
		// Resolve entities
		var regex = new RegExp("<", "g");
		elementData = elementData.replace(regex,"&lt;");
		var regex = new RegExp(">", "g");
		elementData = elementData.replace(regex,"&gt;");
		return elementData;
	}
	var xml = "<" + element.tagName;
	for ( var x = 1 ; x <= element.attributes.length ;  x++ ) {
		var attr = element.attributes[x-1];
		xml += " " + attr.name + "=" + ''"'' + attr.value + ''"'';
	}
	xml += ">";
	for ( var x = 1 ; x <= element.childNodes.length ;  x++ ) {
		var node = element.childNodes[x-1];
		xml += outerXmlString(node);
	}
	xml += "</" + element.tagName + ">";
	return xml;
}

// Function below to get stable equivalent of document.getElementsByTagName("*")
// Credits: http://www.siteexperts.com/tips/contents/ts16/page3.asp
function getAllElements(document)
{
	var elements = [];
	getElements(elements,document.childNodes[0])
	return elements;   
}

// Function below to recursively and deeply collect all sub-elements of an element
// Credits: http://www.siteexperts.com/tips/contents/ts16/page3.asp
function getElements(collection, element) {
	if (element == null) return;
	for ( var x = 1 ; x <= element.childNodes.length ; x++ ) {
		var node = element.childNodes[x-1];
		if (node.nodeType == 1) {
			collection[collection.length] = node[x-1];
				getElements(collection,element);
		}
	}
}

// Function below to detect if the id of any parent of an element is part of an array
function includes(collection, element) {
	var parent = element.parentNode;
	while (parent.tagName) {
		var attributes = parent.attributes;
		if (attributes.length > 0) {
			for ( var ax = 1 ; ax <= attributes.length ; ax++ ) {
				var attr = attributes[ax-1];
				var attrName = attr.name;
				if (attrName == "id") {
					for ( var x = 1 ; x <= collection.length ; x++ ) {
						if (collection[x-1] == attr.value) return true;
					}
				}
			}
		}
		parent = parent.parentNode;
	}
	return false;
}

// Get the text of the body element
function bodyText(doc)
{
	var elements = doc.getElementsByTagName("*");
	if (elements.length == 0) {
		// IE does not support the above, use an alternative hard-coded technique
		elements = getAllElements(doc)
	}
	// Find html elements with the id= attribute
	for ( var x = 1 ; x <= elements.length ; x++ ) {
		var elem = elements[x-1];
		if (elem.tagName == "BODY") {
			var body = xmlString(elem);
		}
	}
	return body;	
}

function debug(aString)
{
	var newDiv = document.createElement("div");
	newDiv.setAttribute("style","position: relative; top: -1.5em; "
		+ "font-size: 60%; font-family: Verdana; color: blue; "
		+ "width: 100%; background-color: lightyellow");
	var textNode = document.createTextNode(aString);
	newDiv.appendChild(textNode);
	document.body.appendChild(newDiv);
}

'! !

!WAAsyncScripts methodsFor: 'accessing' stamp: 'mb 5/3/2007 13:27'!
selectorsToInclude
	^ #( ajaxJs eventTrackingJs liveUpdateJs liveUpdateUtilitiesJs )! !

!Parser methodsFor: '*seasideAsync-squeak' stamp: 'mb 11/6/2006 08:50'!
interactive

	^ (requestor == nil
		or: [requestor isKindOf: SyntaxError]
			or: [requestor isKindOf: WABrowser]
				or: [requestor isKindOf: WAFullClassBrowser]) not! !

!WABrowser class methodsFor: '*seasideAsync' stamp: 'mb 11/6/2006 08:51'!
fullOnClass: aClass selector: aSelector
	"Substitute a more modern browser"
	^WAFullClassBrowser fullOnClass: aClass selector: aSelector! !

WAActionCallback subclass: #WALiveActionCallback
	instanceVariableNames: 'rendererClass callbacks'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SeasideAsync-Rendering'!

!WALiveActionCallback commentStamp: '<historical>' prior: 0!
This idea is from Radoslav Hodnicak
(rh@4096.sk)

Apparently the way LiveUpdate is built currently(SeasideAsync-mb.23), the 
live callbacks have a different session step (_k) than the rest of the page,
i.e. a new continuation for each live callback. If you generate enough of
them, then the original page gets pushed so far back in the history that
it blows the cache. 

Rado's changes fix this problem by processing live callbacks in the same way
normal callbacks are processed, instead of treating them as separate continuations.

The changes are activated in WAHtmlRenderer and WARenderCanvas by sending
#urlForLiveAction: rather than #urlForLiveRequest: The old behavior can be
restored by sending #urlForLiveRequest: rather than #urlForLiveAction:

!

!WALiveActionCallback methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:24'!
callbacks
	^callbacks! !

!WALiveActionCallback methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:24'!
callbacks: anObject
	callbacks := anObject! !

!WALiveActionCallback methodsFor: 'responding' stamp: 'mb 7/6/2007 17:56'!
evaluateWithArgument: argument 
	| currentSession request response renderer document event xmlRoot |
	currentSession := WACurrentSession value.
	request := currentSession currentRequest.
	event := WALiveEvent newFromRequest: request.
	response := WAResponse new.
	response contentType: 'text/xml; charset=utf-8'.
	renderer := self rendererClass context: context copy callbacks: self callbacks.
	document := self newDocumentOn: response.
	renderer context document: document.
	xmlRoot := WAXmlRoot context: renderer context.
	document open: xmlRoot.
	block value: event value: renderer.
	document close.
	currentSession returnResponse: response! !

!WALiveActionCallback methodsFor: 'testing' stamp: 'mb 8/10/2007 07:29'!
isEnabled
	^ true! !

!WALiveActionCallback methodsFor: 'responding' stamp: 'mb 7/6/2007 17:36'!
newDocumentOn: aResponse 
	^WAXmlStreamDocument new stream: aResponse stream.
! !

!WALiveActionCallback methodsFor: 'accessing' stamp: 'mb 3/21/2006 14:21'!
rendererClass
	^rendererClass
! !

!WALiveActionCallback methodsFor: 'accessing' stamp: 'mb 11/14/2006 22:23'!
rendererClass: anObject
	rendererClass := anObject! !

!WAAbstractTextAreaTag methodsFor: '*seasideasync' stamp: 'mb 7/6/2007 17:07'!
liveCallback: liveBlock 
	| uri id |
	id := self ensureId.
	liveBlock fixCallbackTemps.
	uri := canvas
				urlForLiveAction: [:event :h | liveBlock value: event value value: h].
	self session addLoadScript: 'liveSearch(' , id asString printString , ',' , (canvas encode: uri) printString , ')'! !
WAAsyncAutoCompleteTest initialize!
WAAsyncFocusTest initialize!
WAAsyncLiveRequestTest initialize!
WAAsyncPeriodicRequestTest initialize!
WAFullClassBrowser initialize!
